import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

class ChatScreen1 extends StatefulWidget {
  const ChatScreen1({Key? key}) : super(key: key);

  @override
  State<ChatScreen1> createState() => _ChatScreen1State();
}

class _ChatScreen1State extends State<ChatScreen1> {
  final List<Chat> _chat=[
    Chat(
      message:'Hi',
      date:DateTime.parse('2023-06-31 08:12:38'),
      sentByMe:true
    ),

    Chat(
        message:'Hi John, how are you?',
        date:DateTime.parse('2023-06-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'fine, you?',
        date:DateTime.parse('2023-06-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'me too, long time no see',
        date:DateTime.parse('2023-06-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Yes, very busy in work now',
        date:DateTime.parse('2023-06-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'Can we meet?',
        date:DateTime.parse('2023-07-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Yes, next sunday I am free',
        date:DateTime.parse('2023-07-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'Ok, I will call you then',
        date:DateTime.parse('2023-07-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Did you change your job or still working there?',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'No, changed my job last year. Now I am getting more time for me. Last job was eating my whole day time.',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Good to know. Nowadays job is taking full life. No employer wants to give us some time to spent for ourselves',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'Ok, see you later.',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:true
    ),

  ];

  @override
  Widget build(BuildContext context) {
    const myColor=Colors.teal;
    Size screenSize=MediaQuery.of(context).size;
    return  Scaffold(
      body: Column(
        children: [
          Expanded(
            child: ListView.builder(
              shrinkWrap: true,
              itemCount: _chat.length,
                itemBuilder: (context,index){
                  Chat chat=_chat[index];
                  bool issamedate = true;
                  final DateTime date = chat.date;
                  if (index == 0) {
                    issamedate = false;
                  } else {
                    final DateTime prevdate = _chat[index-1].date;
                    issamedate = date.issamedate(prevdate);
                  }
                  if (index == 0 || !(issamedate)){
                  return Column(
                    children: [
                      SizedBox(height: 10,),
                      Divider(),
                      Container(
                        padding: EdgeInsets.symmetric(horizontal: 15,vertical: 8),
                        decoration: BoxDecoration(
                          color: Colors.grey.shade300,borderRadius: BorderRadius.circular(15)
                        ),
                          child: Text(date.formatdate(),style: TextStyle(color:Colors.black87),)),
                      Align(
                        alignment: chat.sentByMe?Alignment.centerRight:Alignment.centerLeft,
                        child: ConstrainedBox(
                          constraints: BoxConstraints(maxWidth: screenSize.width*.9),
                          child: Container(
                            padding: EdgeInsets.symmetric(horizontal: 10,vertical: 10),
                            margin: EdgeInsets.symmetric(horizontal: 20,vertical: 15),

                            decoration: BoxDecoration(
                              color: chat.sentByMe?myColor:Colors.black54,
                              borderRadius: chat.sentByMe?const BorderRadius.only(
                                  bottomRight: Radius.circular(15),
                                  bottomLeft: Radius.circular(15),
                                  topLeft: Radius.circular(15)):
                              const BorderRadius.only(
                                  bottomRight: Radius.circular(15),
                                  bottomLeft: Radius.circular(15),
                                  topRight: Radius.circular(15))

                            ),
                            child: Text(chat.message,style: const TextStyle(
                                color: Colors.white,fontSize: 18
                            ),),
                          ),
                        ),
                      ),
                    ],
                  );
                  }else {
                    return Align(
                      alignment: chat.sentByMe?Alignment.centerRight:Alignment.centerLeft,
                      child: ConstrainedBox(
                        constraints: BoxConstraints(maxWidth: screenSize.width*.9),
                        child: Container(
                          padding: EdgeInsets.symmetric(horizontal: 10,vertical: 10),
                          margin: EdgeInsets.symmetric(horizontal: 20,vertical: 15),

                          decoration: BoxDecoration(
                              color: chat.sentByMe?myColor:Colors.black54,
                              borderRadius: chat.sentByMe?const BorderRadius.only(
                                  bottomRight: Radius.circular(10),
                                  bottomLeft: Radius.circular(10),
                                  topLeft: Radius.circular(10)):
                              const BorderRadius.only(
                                  bottomRight: Radius.circular(10),
                                  bottomLeft: Radius.circular(10),
                                  topRight: Radius.circular(10))

                          ),
                          child: Text(chat.message,style: const TextStyle(
                              color: Colors.white,fontSize: 18
                          ),),
                        ),
                      ),
                    );
                  }
                }),
          ),
          Padding(
            padding: const EdgeInsets.all(8.0),
            child: TextField(
              maxLines: null,
              decoration: InputDecoration(
                prefixIcon: IconButton(onPressed: () {  }, icon: Icon(Icons.emoji_emotions_rounded,size: 25,color: myColor,),),
                suffixIcon: IconButton(onPressed: () {  }, icon: Icon(Icons.send,size: 25,color: myColor,),),
                enabledBorder: OutlineInputBorder(
                  borderSide: BorderSide(width: 2,color: Colors.grey),
                  borderRadius: BorderRadius.circular(15)
                ),
                  focusedBorder: OutlineInputBorder(
                      borderSide: BorderSide(width: 2,color: Colors.teal),
                      borderRadius: BorderRadius.circular(15)
                  ),
                hintText: 'Type here.....'
              ),
              
            ),
          )
        ],
      ),
    );
  }
}

class Chat {
  final String message;
  final DateTime date;
  final bool sentByMe;

  const Chat({
    required this.message,
    required this.date,
    required this.sentByMe
});
}

const String dateformatter = 'dd-MMM, yy';

extension datehelper on DateTime {

  String formatdate() {
    final formatter = DateFormat(dateformatter);
    return formatter.format(this);
  }
  bool issamedate(DateTime other) {
    return this.year == other.year &&
        this.month == other.month &&
        this.day == other.day;
  }

  int getdifferenceindayswithnow() {
    final now = DateTime.now();
    return now.difference(this).inDays;
  }
}
